using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net;
using System.Net.Sockets;
namespace FpClient
{
    public partial class login : Form
    {
        DBClass db = new DBClass();
        public login()
        {
            InitializeComponent();
        }
        string FPpath;
        public static string authen;
        byte[] FPData;
        private void login_Load(object sender, EventArgs e)
        {
            backgroundWorker1.RunWorkerAsync();
            authen = "";
        }

        private void btnBrowse_Click(object sender, EventArgs e)
        {
            openFileDialog1.FileName = "";
            openFileDialog1.ShowDialog();
            FPpath = openFileDialog1.FileName;

            if (FPpath == "")
            {

                MessageBox.Show("Select a Finger Print first", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning); ;

            }
            else
            {
                picFP.ImageLocation = FPpath;
            }
        }

        private void btnEnter_Click(object sender, EventArgs e)
        {
           // authen = "ok";
            if (txtLoginId.Text == "" || txtSecretKey.Text == "" || FPpath == null)
            {
                return;
            }
            string Fpimgpath;
            db.readercommand("select FldLoginId from FPRegister where FldLoginId='" + txtLoginId.Text + "'");
            if (db.sdr.Read())
            {
                home.LoginId = txtLoginId.Text;
            }
            else
            {
                db.con.Close();
                MessageBox.Show("         Invalied LoginId.\r\nGiven LoginId was not Registerd", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            db.readercommand("select FldOrgimg from FPRegister where FldLoginId='" + txtLoginId.Text + "'and FldNicimg='" + FPpath + "'");
            if (db.sdr.Read())
            {
                 Fpimgpath = db.sdr.GetValue(0).ToString();
                 MessageBox.Show("Successfull Login");
                 home.LoginStatus = "In";
                 authen = "Ok";
                 this.Hide();
            }
            else
            {
                Fpimgpath = FPpath;
            }
                //Splitte...
                //string[] fileEntries = Directory.GetFiles("C:/FPRtemp");
                //foreach (string fileName in fileEntries)
                //{
                //    File.Delete(fileName);
                //}
                //string filePath = "";

                //int sliceLen = 1024 * 1024;
                //int counter = 0;

                //string fileDes = Fpimgpath;
                ////fileDes = fileDes.Replace("\\", "/");
                ////while (fileDes.IndexOf("/") > -1)
                ////{
                ////    filePath += fileDes.Substring(0, fileDes.IndexOf("/") + 1);
                ////    fileDes = fileDes.Substring(fileDes.IndexOf("/") + 1);
                ////    //  sourcefile = fileDes.Substring(fileDes.IndexOf("/") + 1);

                ////}


                //string curFileName;

                //BinaryReader br = new BinaryReader(File.Open(fileDes, FileMode.Open));
                ////Check if slice size is grater than file size
                //int len = (int)br.BaseStream.Length;
                //sliceLen = len / Convert.ToInt32(txtSecretKey.Text);
                //byte[] buffer = new byte[sliceLen];
                //if (br.BaseStream.Length < sliceLen)
                //    sliceLen = (int)br.BaseStream.Length;

                ////Slicing work starts here
                //while (br.BaseStream.Length > sliceLen * counter)
                //{
                //    if (br.BaseStream.Length > sliceLen * (counter + 1))
                //    {
                //        br.BaseStream.Read(buffer, 0, sliceLen);
                //        curFileName = "C:/FPRtemp/Sfinger.TIF" + "." + counter.ToString();
                //    }
                //    else
                //    {
                //        int remainLen = (int)br.BaseStream.Length - sliceLen * counter;
                //        buffer = new byte[remainLen];
                //        br.BaseStream.Read(buffer, 0, remainLen);
                //        curFileName = "C:/FPRtemp/Sfinger.TIF" + "." + counter.ToString() + ".E";
                //    }

                //    if (File.Exists(curFileName))
                //        File.Delete(curFileName);

                //    File.WriteAllBytes(curFileName, buffer);
                //    counter++;
                //}
                //br.Close();

                ////Send....
                //byte[] FPId = Encoding.ASCII.GetBytes(txtLoginId.Text + txtSecretKey.Text);
                //int FPIdLen = FPId.Length;
                //byte[] idlen = BitConverter.GetBytes(FPIdLen);
                //string[] fileEntries1 = Directory.GetFiles("C:/FPRtemp");
                //byte[] FPData;
                //foreach (string fileName in fileEntries1)
                //{
                //    string filePath1 = "";

                //    string filesourse = fileName;
                //    filesourse = filesourse.Replace("\\", "/");
                //    while (filesourse.IndexOf("/") > -1)
                //    {
                //        filePath1 += filesourse.Substring(0, filesourse.IndexOf("/") + 1);
                //        filesourse = filesourse.Substring(filesourse.IndexOf("/") + 1);
                //    }


                //    byte[] fileNameByte = Encoding.ASCII.GetBytes(filesourse);
                //    //byte[] reg = Encoding.ASCII.GetBytes("R");

                //    byte[] fileData = File.ReadAllBytes(filePath1 + filesourse);
                //    FPData = new byte[8 + fileNameByte.Length + fileData.Length + FPIdLen];
                //    byte[] fileNameLen = BitConverter.GetBytes(fileNameByte.Length);
                //    idlen.CopyTo(FPData, 0);
                //    FPId.CopyTo(FPData, 4);
                //    fileNameLen.CopyTo(FPData, FPIdLen + 4);
                //    fileNameByte.CopyTo(FPData, FPIdLen + 8);
                //    fileData.CopyTo(FPData, 8 + FPIdLen + fileNameByte.Length);

                //    send(FPData);
                //    System.Threading.Thread.Sleep(2000);
                //}
            //}
            //else
            //{
            //    MessageBox.Show("Invalied LoginId.", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Error);
            //}

        }
        public void send( byte[] cdata)
        {

            string ips = home.Serverip;
            try
            {
                IPAddress[] ipAddress = Dns.GetHostAddresses(ips);
                IPEndPoint ipEnd = new IPEndPoint(ipAddress[0], 102);
                Socket clientSock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.IP);

                clientSock.Connect(ipEnd);
                System.Threading.Thread.Sleep(1000);
                clientSock.Send(cdata);

                clientSock.Close();
            }

            catch (Exception ex)
            {
                if (ex.Message == "A connection attempt failed because the connected party did not properly respond after a period of time, or established connection failed because connected host has failed to respond")
                {
                    //lblError.Text = "";
                    //lblError.Text = "No Such System Available Try other IP";
                }
                else
                {
                    if (ex.Message == "No connection could be made because the target machine actively refused it")
                    {
                        //lblError.Text = "";
                        //lblError.Text = "File Sending fail. Because server not running.";
                    }
                    else
                    {
                        //lblError.Text = "";
                        //lblError.Text = "File Sending fail." + ex.Message;
                    }
                }
            }
           
        }
        private void btn1_Click(object sender, EventArgs e)
        {
            txtLoginId.Text += "1";
        }

        private void btn2_Click(object sender, EventArgs e)
        {
            txtLoginId.Text += "2";

        }

        private void btn3_Click(object sender, EventArgs e)
        {
            txtLoginId.Text += "3";
        }

        private void btn4_Click(object sender, EventArgs e)
        {
            txtLoginId.Text += "4";
        }

        private void btn5_Click(object sender, EventArgs e)
        {
            txtLoginId.Text += "5";
        }

        private void btn6_Click(object sender, EventArgs e)
        {
            txtLoginId.Text += "6";
        }

        private void btn7_Click(object sender, EventArgs e)
        {
            txtLoginId.Text += "7";
        }

        private void btn8_Click(object sender, EventArgs e)
        {
            txtLoginId.Text += "8";
        }

        private void btn9_Click(object sender, EventArgs e)
        {
            txtLoginId.Text += "9";
        }

        private void btn0_Click(object sender, EventArgs e)
        {
            txtLoginId.Text += "0";
        }

        private void btnClear_Click(object sender, EventArgs e)
        {
            txtLoginId.Text = "";
        }

        private void btncancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }
        FPClientCode FPR = new FPClientCode();
        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            FPR.StartServer();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (FPClientCode.curMsg == "Received")
            {
                FPClientCode.curMsg = "";
                if (authen == "Ok")
                {
                    this.Close();
                  
                }
                else
                {
                    MessageBox.Show("Finger Print is Not Valied.", "Result", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                    this.Close();
                }
            }
        }

        private void login_FormClosing(object sender, FormClosingEventArgs e)
        {
            FPClientCode.sock.Close();
        }
    }
    class FPClientCode
    {
        IPEndPoint ipEnd;
       public static  Socket sock;
        string ser1;
        string fileDes, fileini;
        int len;
        public static string[] path = null;
        public FPClientCode()
        {
            IPHostEntry ipEntry = Dns.GetHostEntry(Environment.MachineName);
            IPAddress IpAddr = ipEntry.AddressList[2];
            ipEnd = new IPEndPoint(IpAddr, 201);
            sock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.IP);
            sock.Bind(ipEnd);
           
        }
        public static string receivedPath;
        public static string curMsg = "";
        public static string fileName;
        public void StartServer()
        {
            try
            {

                sock.Listen(100);


                Socket clientSock = sock.Accept();

                byte[] clientData = new byte[10];

                int receivedBytesLen = clientSock.Receive(clientData);
               curMsg = "Received";
                fileName = Encoding.ASCII.GetString(clientData, 0, 2);
                if (fileName == "Ok")
                {
                    login.authen = "Ok";
                    home.LoginStatus = "In";
                   // login.ActiveForm.Close();
                }
                else
                {
                    login.authen = "NotOk";
                    home.LoginStatus = "Out";
                }
                clientSock.Close();
                sock.Close();
               // StartServer();
                

            }
            catch (Exception ex)
            {
                curMsg = "File Receving error.";
            }
        }

    }
}