using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.IO;


namespace FTServerCode
{
    public partial class server : Form
    {
        public server()
        {
            InitializeComponent();
            FPServerCode.receivedPath = "";
        }
        public static string ClientIp;
        private void button1_Click(object sender, EventArgs e)
        {
            if (FPServerCode.receivedPath.Length > 0)
                backgroundWorker1.RunWorkerAsync();
            else
                MessageBox.Show("Please select file receiving path");
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            label5.Text = FPServerCode.receivedPath;
            lblStop.Text = FPServerCode.curMsg;
        }


        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {

            FPR.StartServer();
        }

        private void button2_Click(object sender, EventArgs e)
        {

            if (txtIp.Text != "")
            {
                if (btnOk.Text == "Ok")
                {
                    btnOk.Text = "Cancel";
                    txtIp.Enabled = false;

                }
                else if (btnOk.Text == "Cancel")
                {
                    btnOk.Text = "Ok";
                    txtIp.Enabled = true;
                }
                ClientIp = txtIp.Text;
            }
            else
            {
                MessageBox.Show("Please Enter the Client Ip Address.");
            }
        }
        FPServerCode FPR = new FPServerCode();
        private void server_Load(object sender, EventArgs e)
        {
            backgroundWorker1.RunWorkerAsync();
        }
    }

    class FPServerCode
    {
        IPEndPoint ipEnd;
        Socket sock;
        public FPServerCode()
        {
            IPHostEntry ipEntry = Dns.GetHostEntry(Environment.MachineName);
            IPAddress IpAddr = ipEntry.AddressList[2];
            ipEnd = new IPEndPoint(IpAddr, 102);
            sock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.IP);
            sock.Bind(ipEnd);
        }
        public static string receivedPath;
        public static string curMsg = "Stopped";
        public void StartServer()
        {
            try
            {
                curMsg = "Starting...";
                sock.Listen(100);

                curMsg = "Running and waiting to receive file.";
                Socket clientSock = sock.Accept();

                byte[] clientData = new byte[1024 * 5000];

                int receivedBytesLen = clientSock.Receive(clientData);
                curMsg = "Receiving data...";
                string who = Encoding.ASCII.GetString(clientData, 0, 1);



                if (who == "R")
                {
                    if (System.IO.Directory.Exists("C:/FPRServer") == false)
                    {
                        System.IO.Directory.CreateDirectory("C:/FPRServer");
                    }
                    int fileNameLen1 = BitConverter.ToInt32(clientData, 1);
                    string fileName1 = Encoding.ASCII.GetString(clientData, 5, fileNameLen1);

                    BinaryWriter bWrite1 = new BinaryWriter(File.Open("C:/FPRServer/" + fileName1, FileMode.Append)); ;
                    bWrite1.Write(clientData, 5 + fileNameLen1, receivedBytesLen - (5 + fileNameLen1));

                    curMsg = "Saving file...";

                    bWrite1.Close();
                }
                else
                {
                    if (System.IO.Directory.Exists("C:/FPRServertemp") == false)
                    {
                        System.IO.Directory.CreateDirectory("C:/FPRServertemp");
                    }
                    string[] fileEntries = Directory.GetFiles("C:/FPRServertemp");
                    //foreach (string DfileName in fileEntries)
                    //{
                    //    File.Delete(DfileName);
                    //}
                    int UserCodeLen = BitConverter.ToInt32(clientData, 0);
                    string UserCode = Encoding.ASCII.GetString(clientData, 4, UserCodeLen);
                    int fileNameLen = BitConverter.ToInt32(clientData, UserCodeLen + 4);
                    string fileName = Encoding.ASCII.GetString(clientData, UserCodeLen + 8, fileNameLen);

                    BinaryWriter bWrite = new BinaryWriter(File.Open("C:/FPRServertemp /" + fileName, FileMode.Append)); ;
                    bWrite.Write(clientData, UserCodeLen + 8 + fileNameLen, receivedBytesLen - (UserCodeLen + 8 + fileNameLen));

                    curMsg = "Saving file...";

                    bWrite.Close();



                    string endPart = "C:/FPRServertemp /" + fileName;
                    string orgFile = "";

                    orgFile = endPart.Substring(0, endPart.LastIndexOf("."));
                    endPart = endPart.Substring(endPart.LastIndexOf(".") + 1);

                    if (endPart == "E")//If only one slice is there
                    {
                        orgFile = orgFile.Substring(0, orgFile.LastIndexOf("."));
                        endPart = "0";


                        BinaryWriter bw = new BinaryWriter(File.Open(orgFile, FileMode.Append));
                        string nextFileName = "";
                        byte[] buffer = new byte[bw.BaseStream.Length];


                        int counter = int.Parse(endPart);
                        while (true)
                        {
                            nextFileName = orgFile + "." + counter.ToString();
                            if (File.Exists(nextFileName + ".E"))
                            {
                                //Last slice
                                buffer = File.ReadAllBytes(nextFileName + ".E");
                                bw.Write(buffer);
                                if (File.Exists(nextFileName + ".E"))
                                    File.Delete(nextFileName + ".E");
                                break;
                            }
                            else
                            {
                                buffer = File.ReadAllBytes(nextFileName);
                                bw.Write(buffer);
                            }
                            counter++;
                            if (File.Exists(nextFileName))
                                File.Delete(nextFileName);
                        }
                        bw.Close();
                        MatlabReg();
                        System.Threading.Thread.Sleep(1000);
                        if (System.IO.File.Exists("C:/source/temp.dat"))
                        {

                            System.IO.File.Copy("C:/source/temp.dat", "C:/source/1.dat");
                            System.IO.File.Delete("C:/source/temp.dat");
                            System.IO.File.Delete(" C:/FPRServertemp /Sfinger.TIF");
                        }

                        ///Part2

                        orgFile = "C:/FPRServer/" + UserCode + ".TIF";

                        endPart = "0";


                        BinaryWriter bw1 = new BinaryWriter(File.Open("C:/FPRServertemp/Sfinger.TIF", FileMode.Append));
                        string nextFileName1 = "";
                        byte[] buffer1 = new byte[bw1.BaseStream.Length];


                        int counter1 = int.Parse(endPart);
                        while (true)
                        {
                            nextFileName1 = orgFile + "." + counter1.ToString();
                            if (File.Exists(nextFileName1 + ".E"))
                            {
                                //Last slice
                                buffer1 = File.ReadAllBytes(nextFileName1 + ".E");
                                bw1.Write(buffer1);

                                break;
                            }
                            else
                            {
                                buffer1 = File.ReadAllBytes(nextFileName1);
                                bw1.Write(buffer1);
                            }
                            counter1++;

                        }
                        bw1.Close();
                        MatlabCompare();
                        System.Threading.Thread.Sleep(1000);
                        if (System.IO.File.Exists("C:/source/checkok.dat"))
                        {
                            System.IO.File.Delete("C:/source/checkok.dat");
                            System.IO.File.Delete("C:/source/1.dat");
                            System.IO.File.Delete("C:/source/temp.dat");
                            System.IO.File.Delete(" C:/FPRServertemp /Sfinger.TIF");

                            byte[] temp = Encoding.ASCII.GetBytes("Ok");

                            send(temp);
                        }
                        else
                        {
                            System.IO.File.Delete("C:/source/1.dat");
                            System.IO.File.Delete("C:/source/temp.dat");
                            System.IO.File.Delete(" C:/FPRServertemp /Sfinger.TIF");

                            byte[] temp = Encoding.ASCII.GetBytes("NotOk");

                            send(temp);
                        }
                    }
                }
                clientSock.Close();

                StartServer();
                curMsg = "Reeived & Saved file; Server Stopped.";
            }
            catch (Exception ex)
            {
                curMsg = "File Receving error.";
            }
        }
        string Result;
        private void MatlabReg()
        {
            MLApp.MLAppClass MatLab = new MLApp.MLAppClass();
            MatLab.Execute("Matlab.Application");
            Result = MatLab.Execute("cd c:\\source");
            Result = MatLab.Execute("finger");

        }
        private void MatlabCompare()
        {
            MLApp.MLAppClass MatLab = new MLApp.MLAppClass();
            Result = MatLab.Execute("cd C:\\source");
            Result = MatLab.Execute("finger");
            Result = MatLab.Execute("template=load(char('1.dat'))");
            Result = MatLab.Execute("template1=load(char('temp.dat'))");
            Result = MatLab.Execute("percent_match=match_end(template,template1,10)");

        }
        public void send(byte[] sen)
        {
            try
            {
                IPAddress[] ipAddress = Dns.GetHostAddresses(server.ClientIp);
                IPEndPoint ipEnd = new IPEndPoint(ipAddress[0], 201);
                Socket clientSock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.IP);
                clientSock.Connect(ipEnd);
                System.Threading.Thread.Sleep(1000);
                clientSock.Send(sen);
                clientSock.Close();


            }

            catch (Exception ex)
            {
                if (ex.Message == "A connection attempt failed because the connected party did not properly respond after a period of time, or established connection failed because connected host has failed to respond")
                {
                    //lblError.Text = "";
                    curMsg = "No Such System Available Try other IP";
                }
                else
                {
                    if (ex.Message == "No connection could be made because the target machine actively refused it")
                    {
                        //lblError.Text = "";
                        curMsg = "File Sending fail. Because server not running.";
                    }
                    else
                    {
                        //lblError.Text = "";
                        curMsg = "File Sending fail." + ex.Message;
                    }
                }
            }
        }
    }
}