using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net;
using System.Net.Sockets;

namespace FpClient
{
    public partial class newregistration : Form
    {
        DBClass db = new DBClass();
        public newregistration()
        {
            InitializeComponent();
        }
        string FPPath, Opath, Npath, split;
        private void label3_Click(object sender, EventArgs e)
        {

        }

        private void newregistration_Load(object sender, EventArgs e)
        {
            cbage.SelectedIndex = 0;
        }

        private void btnBrowse_Click(object sender, EventArgs e)
        {
            openFileDialog1.FileName = "";
            openFileDialog1.ShowDialog();
            FPPath = openFileDialog1.FileName;
            picorigional.ImageLocation = FPPath;
            Opath = FPPath;
        }

        private void btnSubmit_Click(object sender, EventArgs e)
        {
            btnSubmit.Enabled = false;
            if (txtName.Text == "" || cbage.SelectedIndex == 0 || txtloginid.Text == "" || txtAddress.Text == "" || txtcontactno.Text == "" || txtspliter.Text == "" || Opath == null || Npath == null || Opath == "" || Npath == "" || split == null)
            {
                MessageBox.Show("You Must Fill all the Fields.                 ", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                return;

            }
            else if (split == null)
            {
                MessageBox.Show("Please Press the Splitte Button");
            }
            else
            {
                string gender="";
                if (rbmale.Checked == true)
                {
                    gender = "Male";
                }
                else
                {
                    gender = "Female";

                }
                try
                {
                    db.insertcommand("insert into FPRegister values(" + txtloginid.Text + ",'" + txtName.Text + "'," + cbage.SelectedItem.ToString() + ",'" + gender + "','" + txtAddress.Text + "','" + txtcontactno.Text + "','" + Opath + "','" + Npath + "')");
                    db.con.Close();
                    string[] fileEntries = Directory.GetFiles("C:/FPRtemp");
                    byte[] FPData;
                    foreach (string fileName in fileEntries)
                    {
                        string filePath = "";

                        string filesourse = fileName;
                        filesourse = filesourse.Replace("\\", "/");
                        while (filesourse.IndexOf("/") > -1)
                        {
                            filePath += filesourse.Substring(0, filesourse.IndexOf("/") + 1);
                            filesourse = filesourse.Substring(filesourse.IndexOf("/") + 1);
                        }


                        byte[] fileNameByte = Encoding.ASCII.GetBytes(filesourse);
                        byte[] reg = Encoding.ASCII.GetBytes("R");

                        byte[] fileData = File.ReadAllBytes(filePath + filesourse);
                        FPData = new byte[4 + fileNameByte.Length + fileData.Length+1];
                        byte[] fileNameLen = BitConverter.GetBytes(fileNameByte.Length);
                        reg.CopyTo(FPData, 0);
                        fileNameLen.CopyTo(FPData, 1);
                        fileNameByte.CopyTo(FPData, 5);
                        fileData.CopyTo(FPData, 5 + fileNameByte.Length);

                        send(FPData);
                        System.Threading.Thread.Sleep(2000);
                        
                    }
                    MessageBox.Show("Successfully Save Your Given Details.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    

                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message.ToString());

                }

            }
            //btnSubmit.Enabled = true ;

        }
        public void send(byte[] cdata)
        {
            string isp = home.Serverip;
           
            try
            {
                IPAddress[] ipAddress = Dns.GetHostAddresses(isp);
                IPEndPoint ipEnd = new IPEndPoint(ipAddress[0], 102);
                Socket clientSock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.IP);

                clientSock.Connect(ipEnd);
                System.Threading.Thread.Sleep(1000);
                clientSock.Send(cdata);

                clientSock.Close();
            }

            catch (Exception ex)
            {
                if (ex.Message == "A connection attempt failed because the connected party did not properly respond after a period of time, or established connection failed because connected host has failed to respond")
                {
                   // lblError.Text = "";
                    //lblError.Text = "No Such System Available Try other IP";
                }
                else
                {
                    if (ex.Message == "No connection could be made because the target machine actively refused it")
                    {
                       // lblError.Text = "";
                        //lblError.Text = "File Sending fail. Because server not running.";
                    }
                    else
                    {
                       // lblError.Text = "";
                        //lblError.Text = "File Sending fail." + ex.Message;
                    }
                }
            }
           
        }
        private void btnAdd_Click(object sender, EventArgs e)
        {
            openFileDialog1.FileName = "";
            openFileDialog1.ShowDialog();
            FPPath = openFileDialog1.FileName;
            picnoice.ImageLocation = FPPath;
            Npath = FPPath;
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnSplitter_Click(object sender, EventArgs e)
        {
            btnSplitter.Enabled = false;
            if (txtspliter.Text != "")
            {
                if (System.IO.Directory.Exists("C:/FPRtemp") == false)
                {
                    System.IO.Directory.CreateDirectory("C:/FPRtemp");
                }
                string[] fileEntries = Directory.GetFiles("C:/FPRtemp");
                foreach (string fileName in fileEntries)
                {
                    File.Delete(fileName);
                }
                try
                {
                    string filePath = "";

                    int sliceLen = 1024 * 1024;
                    int counter = 0;

                    string fileDes = Opath;
                    //fileDes = fileDes.Replace("\\", "/");
                    //while (fileDes.IndexOf("/") > -1)
                    //{
                    //    filePath += fileDes.Substring(0, fileDes.IndexOf("/") + 1);
                    //    fileDes = fileDes.Substring(fileDes.IndexOf("/") + 1);
                    //    //  sourcefile = fileDes.Substring(fileDes.IndexOf("/") + 1);

                    //}


                    string curFileName;

                    BinaryReader br = new BinaryReader(File.Open(fileDes, FileMode.Open));
                    //Check if slice size is grater than file size
                    int len = (int)br.BaseStream.Length;
                    sliceLen = len / Convert.ToInt32(txtspliter.Text);
                    byte[] buffer = new byte[sliceLen];
                    if (br.BaseStream.Length < sliceLen)
                        sliceLen = (int)br.BaseStream.Length;

                    //Slicing work starts here
                    while (br.BaseStream.Length > sliceLen * counter)
                    {
                        if (br.BaseStream.Length > sliceLen * (counter + 1))
                        {
                            br.BaseStream.Read(buffer, 0, sliceLen);
                            curFileName = "C:/FPRtemp/" + txtloginid.Text+txtspliter.Text+".TIF"+ "." + counter.ToString();
                        }
                        else
                        {
                            int remainLen = (int)br.BaseStream.Length - sliceLen * counter;
                            buffer = new byte[remainLen];
                            br.BaseStream.Read(buffer, 0, remainLen);
                            curFileName = "C:/FPRtemp/" + txtloginid.Text + txtspliter.Text + ".TIF" + "." + counter.ToString() + ".E";
                        }

                        if (File.Exists(curFileName))
                            File.Delete(curFileName);

                        File.WriteAllBytes(curFileName, buffer);
                        counter++;
                    }
                    br.Close();
                    split = "ok";

                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message.ToString());
                }
            }
            else
            {
                MessageBox.Show("Enter the Secret Key.", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Question);
            }
        }

        private void txtspliter_TextChanged(object sender, EventArgs e)
        {
            btnSplitter.Enabled = true;
        }

        private void checkavil_Click(object sender, EventArgs e)
        {
            try
            {
                db.readercommand("select *from FPRegister where FldLoginId=" + txtloginid.Text + "");
                if (db.sdr.Read())
                {
                    checkimg.Image = FpClient.Properties.Resources.redx;
                   
                }
                else
                {
                    checkimg.Image = FpClient.Properties.Resources.GreenTick; ;

                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message.ToString());
            }
        }
    }
}